/**
 * Created by RaveYard
 *
 * Youtube		https://www.youtube.com/channel/UCPQojD2Vo3txBMWDlt0Qwlg
 * Discord		RaveYard#2719
 * Discord		https://discord.gg/VTgj9qf
 */
#include <ACS_Zandronum.h>

#define true 1
#define false 0
#define NULL 0

#define HUD_MIN_X 800
#define HUD_MIN_Y 600

#define SELECTED_SCALE 0.95k

// Constants
#define HID_WHEEL 4932

#define MIN_WHEEL_COUNT 2
#define MAX_WHEEL_COUNT 16

#define CURSOR_MAX_DISTANCE_FROM_CENTER 128.0k
#define CURSOR_MIN_DISTANCE_FROM_CENTER 15.0k

typedef __str_ent* __str;
typedef _Accum fixed;

[[call("StkCall")]]
__str getWheelWeapon(int index)
{
	ACS_BeginStrParam();
	ACS_PrintString(s"wpwh_weap");
	ACS_PrintInt(index);
	return ACS_GetCVarString(ACS_EndStrParam());
}
[[call("StkCall")]]
void setWheelWeapon(int index, __str weap)
{
	ACS_BeginStrParam();
	ACS_PrintString(s"wpwh_weap");
	ACS_PrintInt(index);
	ACS_SetCVarString(ACS_EndStrParam(), weap);
}

__addrdef __mod_arr mapscope;

int mapscope isActive;

[[call("StkCall")]]
fixed __floork(fixed k) {
	return (fixed)(int)k;
}

[[call("StkCall")]]
fixed _mink(fixed a, fixed b) {
	return a < b ? a : b;
}
[[call("StkCall")]]
fixed _absk(fixed a) {
	return a < 0 ? -a : a;
}

[[call("StkCall")]]
fixed wrap(fixed a) {
	return a < 0 ? a + 1.0k : a % 1.0k;
}

[[call("StkCall")]]
fixed angleDiff(fixed a, fixed b) {
	fixed d = _absk((b) - (a));
	return _mink(d, 1.0k - d);
}

typedef union FixedIntUnion {
	int i;
	fixed f;
} FixedIntUnion;

[[call("StkCall")]]
__str getFancyName(__str name, int selected)
{
	if(ACS_StrICmp(s"legendary", ACS_StrLeft(name, 9)) == 0) {
		ACS_BeginStrParam();
		if(ACS_GetCVar(s"wpwh_coloredNames")) {
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Ck");
			}
		}

		if(ACS_GetCVar(s"wpwh_shortNames")) {
			ACS_PrintString(ACS_StrMid(name, 9, 32));
		} else {
			ACS_PrintString(name);
		}
		return ACS_EndStrParam();
	}
	if(ACS_StrICmp(s"enraged", ACS_StrLeft(name, 7)) == 0) {
		ACS_BeginStrParam();
		if(ACS_GetCVar(s"wpwh_coloredNames")) {
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Ca");
			}
		}

		int skip = (ACS_GetChar(name, 7) == ' ') ? 8 : 7;

		if(ACS_StrICmp(ACS_StrMid(name, 7, 9), s"legendary") == 0) {
			skip += 9;
		}

		if(ACS_GetCVar(s"wpwh_shortNames")) {
			ACS_PrintString(ACS_StrMid(name, skip, 32));
		} else {
			ACS_PrintString(name);
		}
		return ACS_EndStrParam();
	}
	if(ACS_StrICmp(s"nemesis", ACS_StrLeft(name, 7)) == 0) {
		ACS_BeginStrParam();
		if(ACS_GetCVar(s"wpwh_coloredNames")) {
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Cu");
			}
		}

		if(ACS_GetCVar(s"wpwh_shortNames")) {
			ACS_PrintString(ACS_StrMid(name, 7, 32));
		} else {
			ACS_PrintString(name);
		}
		return ACS_EndStrParam();
	}
	if(ACS_StrICmp(s"BFG", ACS_StrLeft(name, 3)) == 0) {
		ACS_BeginStrParam();

		if(ACS_GetCVar(s"wpwh_coloredNames")) {
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Cd");
			}
		}
		ACS_PrintString(name);
		return ACS_EndStrParam();
	}
	if(ACS_StrICmp(s"Plasma", ACS_StrLeft(name, 6)) == 0 || ACS_StrICmp(s"Railgun", ACS_StrLeft(name, 7)) == 0 || ACS_StrICmp(s"D-BFG", name) == 0) {
		ACS_BeginStrParam();
		if(ACS_GetCVar(s"wpwh_coloredNames")) {
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Cn");
			}
		}
		ACS_PrintString(name);
		return ACS_EndStrParam();
	}
	if(ACS_GetCVar(s"wpwh_coloredNames")) {
		if(ACS_StrICmp(s"DemonTech", ACS_StrLeft(name, 9)) == 0 || ACS_StrICmp(s"Demon Tech", ACS_StrLeft(name, 10)) == 0) {
			ACS_BeginStrParam();
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Cq");
			}
			ACS_PrintString(name);
			return ACS_EndStrParam();
		}
		if(ACS_StrICmp(s"Hell", ACS_StrLeft(name, 4)) == 0) {
			ACS_BeginStrParam();
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Cg");
			}
			ACS_PrintString(name);
			return ACS_EndStrParam();
		}
		if(ACS_StrICmp(s"Pyro", ACS_StrLeft(name, 4)) == 0 || ACS_StrICmp(s"Flame", ACS_StrLeft(name, 4)) == 0 || ACS_StrICmp(s"Explosive", ACS_StrLeft(name, 4)) == 0) {
			ACS_BeginStrParam();
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Cx");
			}
			ACS_PrintString(name);
			return ACS_EndStrParam();
		}
		if(ACS_StrICmp(s"Rocket", ACS_StrLeft(name, 6)) == 0 || ACS_StrICmp(s"Grenade", ACS_StrLeft(name, 7)) == 0 || ACS_StrICmp(s"Homing", ACS_StrLeft(name, 6)) == 0) {
			ACS_BeginStrParam();
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Cb");
			}
			ACS_PrintString(name);
			return ACS_EndStrParam();
		}
		if(ACS_StrICmp(s"Hexa", ACS_StrLeft(name, 4)) == 0 || ACS_StrICmp(s"Quad", ACS_StrLeft(name, 4)) == 0 || ACS_StrICmp(s"Double", ACS_StrLeft(name, 5)) == 0) {
			ACS_BeginStrParam();
			if(selected) {
				ACS_PrintString(s"\Cf");
			} else {
				ACS_PrintString(s"\Cr");
			}
			ACS_PrintString(name);
			return ACS_EndStrParam();
		}
	}
	return name;
}

[[call("ScriptS"), script("clientside"), script("enter"), alloc_Aut(0)]]
void wpwh_run()
{
	if(ACS_PlayerNumber() != ACS_ConsolePlayerNumber()) {
		return;
	}

	reset:;
	fixed cx = 0, cy = 0;
	int selected = -1;
	int prevSelected;
	int holdTime = 0;

	fixed angle, pitch, roll;

	angle = ACS_GetActorAngle(0);
	pitch = ACS_GetActorPitch(0);
	roll = ACS_GetActorRoll(0);

	fixed selectScale = 1.0k;

	while(isActive)
	{
		int hud_x = ACS_GetCVar(s"wpwh_hudx");
		int hud_y = ACS_GetCVar(s"wpwh_hudy");

		if(hud_x < 320) hud_x = HUD_MIN_X;
		if(hud_y < 200) hud_y = HUD_MIN_Y;

		int whCount = ACS_GetCVar(s"wpwh_count");

		if(whCount < MIN_WHEEL_COUNT) {
			whCount = MIN_WHEEL_COUNT;
		} else if(whCount > MAX_WHEEL_COUNT) {
			whCount = MAX_WHEEL_COUNT;
		}

		// Grab input
		fixed mx, my;
		mx = ACS_GetPlayerInputFixed(-1, INPUT_YAW);
		my = ACS_GetPlayerInputFixed(-1, INPUT_PITCH);

		int use = !!(ACS_GetPlayerInput(-1, INPUT_BUTTONS) & BT_USE);
		int usePress = use && !(ACS_GetPlayerInput(-1, INPUT_OLDBUTTONS) & BT_USE);

		cx -= mx * (fixed)(hud_y) * 3.0k * ACS_GetCVarFixed(s"wpwh_sensitivity");
		cy -= my * (fixed)(hud_y) * 3.0k * ACS_GetCVarFixed(s"wpwh_sensitivity");

		// Pick the closest
		prevSelected = selected;
		fixed ca = ACS_VectorAngle(cx, cy);
		fixed adiff = 1.0k;
		for(int i = 0; i < whCount; ++i) {
			fixed ang = ((fixed)i) / whCount;
			// This is kinda dumb, but okay
			fixed cadiff = 0.k;
			if((cadiff = angleDiff(ca, ang)) <= adiff) {
				selected = i;
				adiff = cadiff;
			}
		}

		fixed vlen = ACS_VectorLength(cx, cy);
		if(vlen < CURSOR_MIN_DISTANCE_FROM_CENTER) {
			// Ignore centered mouse
			selected = -1;
		} else if(vlen > CURSOR_MAX_DISTANCE_FROM_CENTER) {
			cx = cx / vlen * CURSOR_MAX_DISTANCE_FROM_CENTER;
			cy = cy / vlen * CURSOR_MAX_DISTANCE_FROM_CENTER;
		}

		// Play sound on change
		if(selected >= 0 && selected != prevSelected) {
			ACS_LocalAmbientSound(s"WeaponWheel/Tick", (int)127 * ACS_GetCVarFixed(s"wpwh_soundvolume"));
		}


		// Print wheel
		ACS_SetFont(s"SmallFont");
		for(int i = 0; i < whCount; ++i) {

			fixed s = selected == i ? selectScale : 1.0k;

			fixed hudScaledX = ((fixed)hud_x) * s;
			fixed hudScaledY = ((fixed)hud_y) * s;

			ACS_SetHudSize(hudScaledX, hudScaledY, false);

			fixed ang = ((fixed)i) / whCount;
			fixed offX = (ACS_Cos(ang) * hudScaledY) / 4;
			fixed offY = (ACS_Sin(ang) * hudScaledY) / 4;

				ACS_BeginHudMessage();
				int cr;
				if(ACS_StrICmp(getWheelWeapon(i), s"None") != 0) {
					if(ACS_GetCVar(s"wpwh_coloredNames") || ACS_GetCVar(s"wpwh_shortNames")) {
						ACS_PrintString(getFancyName(getWheelWeapon(i), i == selected));
					} else {
						ACS_PrintString(getWheelWeapon(i));						
					}
					cr = selected == i ? CR_GOLD : CR_WHITE;
				} else {
					ACS_PrintString(s"x");
					cr = selected == i ? CR_GOLD : CR_DARKRED; 
				}
				ACS_OptHudMessage(HUDMSG_FADEOUT, HID_WHEEL + i, cr, __floork(hudScaledX / 2 + offX), __floork(hudScaledY / 2 + offY), 0.005k);
				ACS_EndHudMessage();
		}

		// Assign weapon
		if(usePress && selected >= 0) {
			__str weap = ACS_GetWeapon();

			if(ACS_StrICmp(weap, getWheelWeapon(selected)) == 0 || weap == getWheelWeapon(selected)) {
				setWheelWeapon(selected, s"None");
				ACS_LocalAmbientSound(s"WeaponWheel/Tick", (int)127 * ACS_GetCVarFixed(s"wpwh_soundvolume"));
			} else {
				setWheelWeapon(selected, weap);
				ACS_LocalAmbientSound(s"WeaponWheel/Assign", (int)127 * ACS_GetCVarFixed(s"wpwh_soundvolume"));
			}
		}


		// Reset hold time if you select other part
		if(selected != prevSelected && selected >= 0) {
			holdTime = 0;
			selectScale = 1.0k;
		} else {
			selectScale = (selectScale - SELECTED_SCALE) * 0.125k + SELECTED_SCALE;
		}

		// Hold to unassign
		if(use) {
			holdTime++;

			if(holdTime == 15) {
				setWheelWeapon(selected, s"None");
				ACS_LocalAmbientSound(s"WeaponWheel/Tick", (int)127 * ACS_GetCVarFixed(s"wpwh_soundvolume"));
			}
		} else {
			holdTime = 0;
		}

		ACS_SetHudSize(hud_x, hud_y, false);

		// Draw cursor
		ACS_SetFont(s"CURSOR");
		ACS_BeginHudMessage();
		ACS_PrintChar('A');
		ACS_OptHudMessage(HUDMSG_FADEOUT, HID_WHEEL + whCount + 1, CR_RED, __floork(hud_x / 2 + cx), __floork(hud_y / 2 + cy), 0.005k);
		ACS_EndHudMessage();

		if(ACS_GetCVar(s"wpwh_freezeCamera")) {
			ACS_ChangeActorAngle(0, angle, true);
			ACS_ChangeActorPitch(0, pitch, true);
			ACS_ChangeActorRoll(0, roll, true);
		}
		ACS_Delay(1);
	}

	if(selected >= 0) {
		if(ACS_GetCVar(s"wpwh_useCCMD")) {
			ACS_BeginStrParam();
			ACS_PrintString(s"use \"");
			ACS_PrintString(getWheelWeapon(selected));
			ACS_PrintChar('"');
			ACS_ConsoleCommand(ACS_EndStrParam());	
		} else {
			ACS_SetWeapon(getWheelWeapon(selected));
		}
	}

	while(!isActive)
	{
		ACS_Delay(1);
	}
	goto reset;
}

[[address("wpwh_set"), call("ScriptS"), script("clientside"), script("net"), alloc_Aut(0)]]
void wpwh_set(int active)
{
	isActive = !!active;
}